/********************************************************************/
/* Copyright (c) 2019 System fugen G.K. and Yuzi Mizuno          */
/* All rights reserved.                                             */
/* ***************************************************** */
/********************************************************************/
/**
 * @file SplineInterpTool.h
 * @brief MGSplineInterpTool クラスのインターフェイス
 */
#ifndef _MGSplineGen_HH_
#define _MGSplineGen_HH_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Common/LocateState.h"
#include "mg/LBRepEndC.h"
#include "Calc/curve.h"

/// @class MGSplineInterpTool SplineInterpTool.h "CurveCmd/SplineInterpTool.h"
///
/// 補間点指定によるスプライン生成コマンド
class MGSplineInterpTool : public MGLocateState{
public:
	explicit MGSplineInterpTool(fugenDoc* pDoc);
	virtual MGCommandBase* initial_clone(fugenDoc* pDoc)const;
	virtual bool initiate_tool();
	virtual bool terminate_tool(bool cancel = false);
	virtual bool OnKeyDown(fugenView* pView, UINT nChar, UINT nRepCnt, UINT nFlags);
	virtual bool OnLocated(const MGLocateInfo& info);
	virtual void do_make_temporary_display(mgSysGL& sgl,fugenView* pSView);

private:
	bool calculate();
	bool get_curve(const std::vector<MGPosition>& ip);
	void prompt_message() const;

	std::unique_ptr<MGCurve> m_curve; ///< 一時描画用
	UINT m_nIDS; ///< error message

	int m_nDegree; ///< 曲線の次数 (== order - 1)
	bool m_1stDerivS;///<indicates if 1st derivative is allowed to input for the start point.
	MGLBRepEndC m_cndStart; ///< 曲線の始点における接線方向 (optional)
	MGLocateInfo m_linfo;///<to store the end point's MGLocateinfo.
	bool m_1stDerivE;///<indicates if 1st derivative is allowed to input for the end point.
	MGLBRepEndC m_cndEnd; ///< 曲線の終点における接線方向 (optional)
	bool m_bClose; ///< 曲線を閉じるかどうか
	bool m_bSharp; ///< 曲線を閉じるのであれば、始終点はキンクにするか
};

#endif
